<template>
  <rui-form :errors="errors"
            model="task"
            :loading="loading"
            @cancel="$emit('cancel')"
            @submit.prevent="save">
    <rui-field :input-id="`${formId}-name`" :label="$t('activerecord.attributes.task.name')">
      <input :id="`${formId}-name`" v-model="inputs.name" type="text" required>
      <template #help>
        <div v-if="taskNames.length > 0" class="rui-field__help">
          {{ $t('js.tasks.form.recent_tasks') }}
          <rui-toolbar>
            <rui-button v-for="name in taskNames"
                        :key="name"
                        size="small"
                        :caption="name"
                        @click="inputs.name = name" />
          </rui-toolbar>
        </div>
      </template>
    </rui-field>

    <rui-field v-if="teamMatesUsers.length > 1" :input-id="`${formId}-assignee_id`" :label="$t('activerecord.attributes.task.assignee')">
      <select :id="`${formId}-assignee_id`" v-model="inputs.assignee_id">
        <option v-for="teamMate in teamMatesUsers" :key="teamMate.id" :value="teamMate.id">{{ teamMate.username }}</option>
      </select>
    </rui-field>

    <rui-date-time-picker ref="datePicker"
                          v-model="selectedDate"
                          :label="$t('activerecord.attributes.task.planned_for')"
                          :time="false"
                          :input-id="`${formId}-date`"
                          :popup="true"
                          input-name="date" />

    <div v-if="isOver">
      <label><input v-model="markDone" type="checkbox">{{ $t('js.tasks.form.mark_as_done') }}</label>
    </div>

    <rui-field :input-id="`${formId}-notes`" :label="$t('activerecord.attributes.task.notes')">
      <textarea :id="`${formId}-notes`" v-model="inputs.notes" name="notes" />
    </rui-field>
  </rui-form>
</template>

<script>
import RuiButton from '@experiments-labs/rise_ui/src/components/Button/Button.vue'
import RuiField from '@experiments-labs/rise_ui/src/components/Form/Field.vue'
import RuiForm from '@experiments-labs/rise_ui/src/components/Form/Form.vue'
import RuiDateTimePicker from '@experiments-labs/rise_ui/src/components/Inputs/DateTimePicker/DateTimePicker.vue'
import RuiToolbar from '@experiments-labs/rise_ui/src/components/Toolbar/Toolbar.vue'

import { randomString } from '@experiments-labs/rise_ui/src/lib/String.js'
import { isOver, isSameDay } from '@experiments-labs/rise_ui/src/lib/Dates'
import Toaster from '../../../../tools/Toaster'
import Element from '../../../../classes/models/Element'
import Map from '../../../../classes/models/Map'
import Patch from '../../../../classes/models/Patch'
import Path from '../../../../classes/models/Path'

export default {
  name: 'GpaTaskForm',
  emits: [
    'cancel',
    'done',
  ],
  components: { RuiDateTimePicker, RuiButton, RuiToolbar, RuiField, RuiForm },
  props: {
    subject: { required: true, type: [Element, Map, Patch, Path] },
  },
  data () {
    return {
      loading: false,
      errors: null,
      formId: randomString(),
      today: new Date(),
      selectedDate: new Date(),
      markDone: false,
      inputs: {
        name: '',
        notes: '',
        assignee_id: '',
      },
    }
  },
  computed: {
    taskNames () { return this.$store.getters.taskNames },
    accountUser () { return this.$store.getters.account.toUser() },
    teamMatesUsers () {
      const teamMates = this.$store.getters.teamMates.map(t => t.user)
      return teamMates.sort((a, b) => a.username.localeCompare(b.username))
    },
    isOver () {
      if (!this.selectedDate) return false

      return isOver(this.selectedDate, this.today) || isSameDay(this.selectedDate, this.today)
    },
  },
  methods: {
    save () {
      this.errors = null
      const payload = {
        notes: this.inputs.notes,
        subject_id: this.$props.subject.id,
        subject_type: this.$props.subject.className,
        name: this.inputs.name,
        assignee_id: this.inputs.assignee_id,
        planned_for: this.selectedDate,
      }

      if (this.isOver && this.markDone) {
        payload.done_at = this.selectedDate
      }

      this.loading = true
      this.$store.dispatch('createTask', payload)
        .then((task) => {
          this.$emit('done')
          this.$store.dispatch('addTaskName', task.name)
          Toaster.success(this.$t('js.task.successfully_created'))
        })
        .catch((error) => {
          this.errors = error
          Toaster.error(this.$t('js.task.failed_to_create'))
        })
        .then(() => { this.loading = false })
    },
  },
  mounted () {
    this.inputs.assignee_id = this.accountUser.id
  },
  watch: {
    action () {
      this.$refs.datePicker.close()
      this.inputs.name = ''
      this.inputs.notes = ''
      this.selectedDate = new Date()
    },
    selectedDate (newValue) {
      if (!newValue) return

      if (isSameDay(newValue, this.today)) this.markDone = false
      else this.markDone = isOver(newValue, this.today)
    },
  },
}
</script>
